/*!
  SerializeJSON jQuery plugin.
  https://github.com/marioizquierdo/jquery.serializeJSON
  version 2.4.1 (Oct, 2014)

  Copyright (c) 2014 Mario Izquierdo
  Dual licensed under the MIT (http://www.opensource.org/licenses/mit-license.php)
  and GPL (http://www.opensource.org/licenses/gpl-license.php) licenses.
*/
(function(e){"use strict";e.fn.serializeJSON=function(t){var n,r,i,s,o,u,a,f;a=e.serializeJSON;f=a.optsWithDefaults(t);a.validateOptions(f);r=this.serializeArray();a.readCheckboxUncheckedValues(r,this,f);n={};e.each(r,function(e,t){i=a.splitInputNameIntoKeysArray(t.name);s=i.pop();if(s!=="skip"){o=a.parseValue(t.value,s,f);if(f.parseWithFunction&&s==="_")o=f.parseWithFunction(o,t.name);a.deepSet(n,i,o,f)}});return n};e.serializeJSON={defaultOptions:{parseNumbers:false,parseBooleans:false,parseNulls:false,parseAll:false,parseWithFunction:null,checkboxUncheckedValue:undefined,useIntKeysAsArrayIndex:false},optsWithDefaults:function(t){var n,r;if(t==null)t={};n=e.serializeJSON;r=n.optWithDefaults("parseAll",t);return{parseNumbers:r||n.optWithDefaults("parseNumbers",t),parseBooleans:r||n.optWithDefaults("parseBooleans",t),parseNulls:r||n.optWithDefaults("parseNulls",t),parseWithFunction:n.optWithDefaults("parseWithFunction",t),checkboxUncheckedValue:n.optWithDefaults("checkboxUncheckedValue",t),useIntKeysAsArrayIndex:n.optWithDefaults("useIntKeysAsArrayIndex",t)}},optWithDefaults:function(t,n){return n[t]!==false&&n[t]!==""&&(n[t]||e.serializeJSON.defaultOptions[t])},validateOptions:function(e){var t,n;n=["parseNumbers","parseBooleans","parseNulls","parseAll","parseWithFunction","checkboxUncheckedValue","useIntKeysAsArrayIndex"];for(t in e){if(n.indexOf(t)===-1){throw new Error("serializeJSON ERROR: invalid option '"+t+"'. Please use one of "+n.join(","))}}},parseValue:function(t,n,r){var i,s;s=e.serializeJSON;if(n=="string")return t;if(n=="number"||r.parseNumbers&&s.isNumeric(t))return Number(t);if(n=="boolean"||r.parseBooleans&&(t==="true"||t==="false"))return["false","null","undefined","","0"].indexOf(t)===-1;if(n=="null"||r.parseNulls&&t=="null")return["false","null","undefined","","0"].indexOf(t)!==-1?null:t;if(n=="array"||n=="object")return JSON.parse(t);if(n=="auto")return s.parseValue(t,null,{parseNumbers:true,parseBooleans:true,parseNulls:true});return t},isObject:function(e){return e===Object(e)},isUndefined:function(e){return e===void 0},isValidArrayIndex:function(e){return/^[0-9]+$/.test(String(e))},isNumeric:function(e){return e-parseFloat(e)>=0},splitInputNameIntoKeysArray:function(t){var n,r,i,s,o;o=e.serializeJSON;s=o.extractTypeFromInputName(t),r=s[0],i=s[1];n=r.split("[");n=e.map(n,function(e){return e.replace(/]/g,"")});if(n[0]===""){n.shift()}n.push(i);return n},extractTypeFromInputName:function(t){var n,r;r=e.serializeJSON;if(n=t.match(/(.*):([^:]+)$/)){var i=["string","number","boolean","null","array","object","skip","auto"];if(i.indexOf(n[2])!==-1){return[n[1],n[2]]}else{throw new Error("serializeJSON ERROR: Invalid type "+n[2]+" found in input name '"+t+"', please use one of "+i.join(", "))}}else{return[t,"_"]}},deepSet:function(t,n,r,i){var s,o,u,a,f,l;if(i==null)i={};l=e.serializeJSON;if(l.isUndefined(t)){throw new Error("ArgumentError: param 'o' expected to be an object or array, found undefined")}if(!n||n.length===0){throw new Error("ArgumentError: param 'keys' expected to be an array with least one element")}s=n[0];if(n.length===1){if(s===""){t.push(r)}else{t[s]=r}}else{o=n[1];if(s===""){a=t.length-1;f=t[a];if(l.isObject(f)&&(l.isUndefined(f[o])||n.length>2)){s=a}else{s=a+1}}if(l.isUndefined(t[s])){if(o===""){t[s]=[]}else if(i.useIntKeysAsArrayIndex&&l.isValidArrayIndex(o)){t[s]=[]}else{t[s]={}}}u=n.slice(1);l.deepSet(t[s],u,r,i)}},readCheckboxUncheckedValues:function(t,n,r){var i,s,o,u,a;if(r==null)r={};a=e.serializeJSON;i="input[type=checkbox][name]:not(:checked,[disabled])";s=n.find(i).add(n.filter(i));s.each(function(n,i){o=e(i);u=o.attr("data-unchecked-value");if(u){t.push({name:i.name,value:u})}else{if(!a.isUndefined(r.checkboxUncheckedValue)){t.push({name:i.name,value:r.checkboxUncheckedValue})}}})}}})(window.jQuery||window.Zepto||window.$)